Imports System.ComponentModel


Public Class VoteValueCell
    Inherits DataGridViewTextBoxCell

    Public Sub New()

    End Sub

    Public Overrides Sub InitializeEditingControl(ByVal rowIndex As Integer, ByVal initialFormattedValue As Object, ByVal dataGridViewCellStyle As System.Windows.Forms.DataGridViewCellStyle)
        MyBase.InitializeEditingControl(rowIndex, initialFormattedValue, dataGridViewCellStyle)

        Dim propertyDescriptor As VoteValuePropertyDescriptor = _
        CType(CType(DataGridView.DataSource, ITypedList).GetItemProperties(Nothing)(DataGridView.Columns(ColumnIndex).DataPropertyName), VoteValuePropertyDescriptor)
        Dim voteValue As Integer = CInt(Value)
        Dim remainingVoteValue As Integer = Math.Max(100 - propertyDescriptor.CalcPrioritySumForYear() + voteValue, 0)

        Dim control As VoteValueEditingControl = CType(DataGridView.EditingControl, VoteValueEditingControl)
        control.ResetControl(voteValue, remainingVoteValue)
    End Sub

    Public Overrides ReadOnly Property EditType() As System.Type
        Get
            Return GetType(VoteValueEditingControl)
        End Get
    End Property

    Public Overrides ReadOnly Property ValueType() As System.Type
        Get
            Return GetType(Integer)
        End Get
    End Property

    Public Overrides ReadOnly Property DefaultNewRowValue() As Object
        Get
            Return 0
        End Get
    End Property
End Class
