Public Class VoteValueEditor
    Public Sub New()
        InitializeComponent()

        ResetControl(0, 100)
    End Sub

    Public Sub ResetControl(ByVal initialValue As Integer, ByVal maxValidValue As Integer)
        trackBar.DataBindings.Clear()
        valueLabel.DataBindings.Clear()

        _maxValidValue = maxValidValue
        _value = initialValue
        EvaluateValueValidity()

        trackBar.DataBindings.Add("Value", Me, "Value", False, DataSourceUpdateMode.OnPropertyChanged)
        valueLabel.DataBindings.Add("Text", Me, "Value")
    End Sub

    Private _value As Integer
    Public Property Value() As Integer
        Get
            Return _value
        End Get
        Set(ByVal Value As Integer)
            _value = Value
            EvaluateValueValidity()
            OnValueChanged(EventArgs.Empty)
        End Set
    End Property

    Private _maxValidValue As Integer
    Public Property MaxValidValue() As Integer
        Get
            Return _maxValidValue
        End Get
        Set(ByVal Value As Integer)
            _maxValidValue = Value
            EvaluateValueValidity()
        End Set
    End Property

    Private Sub EvaluateValueValidity()
        BackColor = IIf(_value <= _maxValidValue, SystemColors.Control, Color.Red)
    End Sub

    Public Event ValueChanged As EventHandler

    Protected Overridable Sub OnValueChanged(ByVal _eventArgs As EventArgs)
        RaiseEvent ValueChanged(Me, _eventArgs)
    End Sub

End Class
