Imports System.ComponentModel


Public Class TypedListWrapperBindingListT(Of T)
    Inherits BindingList(Of T)
    Implements IBindingList, IList(Of T), ITypedList, ICancelAddNew, IRaiseItemChangedEvents

    Public Sub New()

    End Sub

    Public Sub New(ByVal wrappedBindingListT As BindingList(Of T))
        _wrappedBindingListT = wrappedBindingListT
    End Sub

    Public Sub New(ByVal wrappedBindingListT As BindingList(Of T), ByVal propertyDescriptorCollection As PropertyDescriptorCollection)
        _wrappedBindingListT = wrappedBindingListT
        _propertyDescriptorCollection = propertyDescriptorCollection
    End Sub

    Public Sub New(ByVal propertyDescriptorCollection As PropertyDescriptorCollection)
        _propertyDescriptorCollection = propertyDescriptorCollection
    End Sub

    Private _wrappedBindingListT As BindingList(Of T)
    Public Property WrappedBindingListT() As BindingList(Of T)
        Get
            Return _wrappedBindingListT
        End Get
        Set(ByVal Value As BindingList(Of T))
            _wrappedBindingListT = Value
        End Set
    End Property

    Private _propertyDescriptorCollection As PropertyDescriptorCollection
    Public Property PropertyDescriptorCollection() As PropertyDescriptorCollection
        Get
            Return _propertyDescriptorCollection
        End Get
        Set(ByVal Value As PropertyDescriptorCollection)
            _propertyDescriptorCollection = Value
        End Set
    End Property

    Private _listName As String = "Default"
    Public Property ListName() As String
        Get
            Return _listName
        End Get
        Set(ByVal Value As String)
            _listName = Value
        End Set
    End Property

#Region "IList, ICollection, IEnumerable"
    Private Sub ICollection_CopyTo(ByVal array As System.Array, ByVal index As Integer) Implements System.Collections.ICollection.CopyTo
        _wrappedBindingListT.CopyTo(array, index)
    End Sub

    Private ReadOnly Property ICollection_Count() As Integer Implements System.Collections.ICollection.Count
        Get
            Return _wrappedBindingListT.Count
        End Get
    End Property

    Private ReadOnly Property ICollection_IsSynchronized() As Boolean Implements System.Collections.ICollection.IsSynchronized
        Get
            Return CType(_wrappedBindingListT, ICollection).IsSynchronized
        End Get
    End Property

    Private ReadOnly Property ICollection_SyncRoot() As Object Implements System.Collections.ICollection.SyncRoot
        Get
            Return CType(_wrappedBindingListT, ICollection).SyncRoot
        End Get
    End Property

    Private Function IEnumerable_GetEnumerator() As System.Collections.IEnumerator Implements System.Collections.IEnumerable.GetEnumerator
        Return _wrappedBindingListT.GetEnumerator
    End Function

    Private Function IList_Add(ByVal value As Object) As Integer Implements System.Collections.IList.Add
        Return CType(_wrappedBindingListT, IList).Add(value)
    End Function

    Private Sub IList_Clear() Implements System.Collections.IList.Clear
        _wrappedBindingListT.Clear()
    End Sub

    Private Function IList_Contains(ByVal value As Object) As Boolean Implements System.Collections.IList.Contains
        Return _wrappedBindingListT.Contains(value)
    End Function

    Private Function IList_IndexOf(ByVal value As Object) As Integer Implements System.Collections.IList.IndexOf
        Return _wrappedBindingListT.IndexOf(value)
    End Function

    Private Sub IList_Insert(ByVal index As Integer, ByVal value As Object) Implements System.Collections.IList.Insert
        _wrappedBindingListT.Insert(index, value)
    End Sub

    Private ReadOnly Property IList_IsFixedSize() As Boolean Implements System.Collections.IList.IsFixedSize
        Get
            Return CType(_wrappedBindingListT, IList).IsFixedSize
        End Get
    End Property

    Private ReadOnly Property IList_IsReadOnly() As Boolean Implements System.Collections.IList.IsReadOnly
        Get
            Return CType(_wrappedBindingListT, IList).IsReadOnly
        End Get
    End Property

    Private Property IList_Item(ByVal index As Integer) As Object Implements System.Collections.IList.Item
        Get
            Return _wrappedBindingListT.Item(index)
        End Get
        Set(ByVal value As Object)
            _wrappedBindingListT.Item(index) = value
        End Set
    End Property

    Private Sub IList_Remove(ByVal value As Object) Implements System.Collections.IList.Remove
        _wrappedBindingListT.Remove(value)
    End Sub

    Private Sub IList_RemoveAt(ByVal index As Integer) Implements System.Collections.IList.RemoveAt
        _wrappedBindingListT.RemoveAt(index)
    End Sub
#End Region

#Region "IList(Of T), ICollection(Of T), IEnumerable(Of T)"
    Private Sub ICollectionT_Add(ByVal item As T) Implements System.Collections.Generic.ICollection(Of T).Add
        _wrappedBindingListT.Add(item)
    End Sub

    Private Sub ICollectionT_Clear() Implements System.Collections.Generic.ICollection(Of T).Clear
        _wrappedBindingListT.Clear()
    End Sub

    Private Function ICollectionT_Contains(ByVal item As T) As Boolean Implements System.Collections.Generic.ICollection(Of T).Contains
        Return _wrappedBindingListT.Contains(item)
    End Function

    Private Sub ICollectionT_CopyTo(ByVal array() As T, ByVal arrayIndex As Integer) Implements System.Collections.Generic.ICollection(Of T).CopyTo
        _wrappedBindingListT.CopyTo(array, arrayIndex)
    End Sub

    Private ReadOnly Property ICollectionT_Count() As Integer Implements System.Collections.Generic.ICollection(Of T).Count
        Get
            Return _wrappedBindingListT.Count
        End Get
    End Property

    Private ReadOnly Property ICollectionT_IsReadOnly() As Boolean Implements System.Collections.Generic.ICollection(Of T).IsReadOnly
        Get
            Return CType(_wrappedBindingListT, ICollection(Of T)).IsReadOnly
        End Get
    End Property

    Private Function ICollectionT_Remove(ByVal item As T) As Boolean Implements System.Collections.Generic.ICollection(Of T).Remove
        Return _wrappedBindingListT.Remove(item)
    End Function

    Private Function IEnumerableT_GetEnumerator() As System.Collections.Generic.IEnumerator(Of T) Implements System.Collections.Generic.IEnumerable(Of T).GetEnumerator
        Return _wrappedBindingListT.GetEnumerator
    End Function

    Private Function IListT_IndexOf(ByVal item As T) As Integer Implements System.Collections.Generic.IList(Of T).IndexOf
        Return _wrappedBindingListT.IndexOf(item)
    End Function

    Private Sub IListT_Insert(ByVal index As Integer, ByVal item As T) Implements System.Collections.Generic.IList(Of T).Insert
        _wrappedBindingListT.Insert(index, item)
    End Sub

    Private Property IListT_Item(ByVal index As Integer) As T Implements System.Collections.Generic.IList(Of T).Item
        Get
            Return _wrappedBindingListT.Item(index)
        End Get
        Set(ByVal value As T)
            _wrappedBindingListT.Item(index) = value
        End Set
    End Property

    Private Sub IListT_RemoveAt(ByVal index As Integer) Implements System.Collections.Generic.IList(Of T).RemoveAt
        _wrappedBindingListT.RemoveAt(index)
    End Sub
#End Region

#Region "ITypedList"
    Private Function ITypedList_GetItemProperties(ByVal listAccessors() As System.ComponentModel.PropertyDescriptor) As System.ComponentModel.PropertyDescriptorCollection Implements System.ComponentModel.ITypedList.GetItemProperties
        Return _propertyDescriptorCollection
    End Function

    Private Function ITypedList_GetListName(ByVal listAccessors() As System.ComponentModel.PropertyDescriptor) As String Implements System.ComponentModel.ITypedList.GetListName
        Return _listName
    End Function
#End Region

#Region "IBindingList"
    Private Sub IBindingList_AddIndex(ByVal [property] As System.ComponentModel.PropertyDescriptor) Implements System.ComponentModel.IBindingList.AddIndex
        CType(_wrappedBindingListT, IBindingList).AddIndex([property])
    End Sub

    Private Function IBindingList_AddNew() As Object Implements System.ComponentModel.IBindingList.AddNew
        Return _wrappedBindingListT.AddNew
    End Function

    Private ReadOnly Property IBindingList_AllowEdit() As Boolean Implements System.ComponentModel.IBindingList.AllowEdit
        Get
            Return _wrappedBindingListT.AllowEdit
        End Get
    End Property

    Private ReadOnly Property IBindingList_AllowNew() As Boolean Implements System.ComponentModel.IBindingList.AllowNew
        Get
            Return _wrappedBindingListT.AllowNew
        End Get
    End Property

    Private ReadOnly Property IBindingList_AllowRemove() As Boolean Implements System.ComponentModel.IBindingList.AllowRemove
        Get
            Return _wrappedBindingListT.AllowRemove
        End Get
    End Property

    Private Sub IBindingList_ApplySort(ByVal [property] As System.ComponentModel.PropertyDescriptor, ByVal direction As System.ComponentModel.ListSortDirection) Implements System.ComponentModel.IBindingList.ApplySort
        CType(_wrappedBindingListT, IBindingList).ApplySort([property], direction)
    End Sub

    Private Function IBindingList_Find(ByVal [property] As System.ComponentModel.PropertyDescriptor, ByVal key As Object) As Integer Implements System.ComponentModel.IBindingList.Find
        Return CType(_wrappedBindingListT, IBindingList).Find([property], key)
    End Function

    Private ReadOnly Property IBindingList_IsSorted() As Boolean Implements System.ComponentModel.IBindingList.IsSorted
        Get
            Return CType(_wrappedBindingListT, IBindingList).IsSorted
        End Get
    End Property

    Private Custom Event IBindingList_ListChanged As ListChangedEventHandler Implements System.ComponentModel.IBindingList.ListChanged
        AddHandler(ByVal value As ListChangedEventHandler)
            AddHandler CType(_wrappedBindingListT, IBindingList).ListChanged, value
        End AddHandler

        RemoveHandler(ByVal value As ListChangedEventHandler)
            RemoveHandler CType(_wrappedBindingListT, IBindingList).ListChanged, value
        End RemoveHandler

        RaiseEvent(ByVal sender As Object, ByVal e As System.ComponentModel.ListChangedEventArgs)

        End RaiseEvent
    End Event

    Private Sub IBindingList_RemoveIndex(ByVal [property] As System.ComponentModel.PropertyDescriptor) Implements System.ComponentModel.IBindingList.RemoveIndex
        CType(_wrappedBindingListT, IBindingList).RemoveIndex([property])
    End Sub

    Private Sub IBindingList_RemoveSort() Implements System.ComponentModel.IBindingList.RemoveSort
        CType(_wrappedBindingListT, IBindingList).RemoveSort()
    End Sub

    Private ReadOnly Property IBindingList_SortDirection() As System.ComponentModel.ListSortDirection Implements System.ComponentModel.IBindingList.SortDirection
        Get
            Return CType(_wrappedBindingListT, IBindingList).SortDirection()
        End Get
    End Property

    Private ReadOnly Property IBindingList_SortProperty() As System.ComponentModel.PropertyDescriptor Implements System.ComponentModel.IBindingList.SortProperty
        Get
            Return CType(_wrappedBindingListT, IBindingList).SortProperty
        End Get
    End Property

    Private ReadOnly Property IBindingList_SupportsChangeNotification() As Boolean Implements System.ComponentModel.IBindingList.SupportsChangeNotification
        Get
            Return CType(_wrappedBindingListT, IBindingList).SupportsChangeNotification
        End Get
    End Property

    Private ReadOnly Property IBindingList_SupportsSearching() As Boolean Implements System.ComponentModel.IBindingList.SupportsSearching
        Get
            Return CType(_wrappedBindingListT, IBindingList).SupportsSearching
        End Get
    End Property

    Private ReadOnly Property IBindingList_SupportsSorting() As Boolean Implements System.ComponentModel.IBindingList.SupportsSorting
        Get
            Return CType(_wrappedBindingListT, IBindingList).SupportsSorting
        End Get
    End Property
#End Region

#Region "ICancelAddNew"
    Private Sub ICancelAddNew_CancelNew(ByVal itemIndex As Integer) Implements ICancelAddNew.CancelNew
        _wrappedBindingListT.CancelNew(itemIndex)
    End Sub

    Private Sub ICancelAddNew_EndNew(ByVal itemIndex As Integer) Implements ICancelAddNew.EndNew
        _wrappedBindingListT.EndNew(itemIndex)
    End Sub
#End Region

#Region "IRaiseItemChangedEvents"
    Private ReadOnly Property IRaiseItemChangedEvents_RaisesItemChangedEvents() As Boolean Implements IRaiseItemChangedEvents.RaisesItemChangedEvents
        Get
            Return CType(_wrappedBindingListT, IRaiseItemChangedEvents).RaisesItemChangedEvents
        End Get
    End Property
#End Region

End Class
